# (c) 2011 Arvydas Burdulis
# http://ae.gamedev.lt

import bpy
import struct
from array import array

zingsniai = 32
failo_pavadinimas = "G:/AB/Prog/Labirintas_3D/bin/test.bin"

print("\nPradedamas eksportavimas")

def Skaiciuoti(obj):
    x1 = obj.bound_box[0][0]
    x2 = obj.bound_box[4][0]
    y1 = obj.bound_box[0][1]
    y2 = obj.bound_box[2][1]
    z1 = obj.bound_box[0][2]
    z2 = obj.bound_box[1][2]
    diff = x2 - x1
    if (y2 - y1) > diff:
        diff = y2 - y1
    if (z2 - z1) > diff:
        diff = z2 - z1
    
    dx = diff / (zingsniai - 1)
    z_maks = z1 + diff * 2
    duom = array('B')
    for i in range(0, zingsniai):
        for j in range(0, zingsniai):
            for k in range(0, zingsniai):
                (poz, norm, id) = obj.ray_cast([x1 + i * dx, y1 + j * dx, z1 + k * dx], [x1 + i * dx, y1 + j * dx, z_maks])
                if norm[2] > 0.01:
                    duom.append(1)
                else:
                    duom.append(0)
    failas = open(failo_pavadinimas, "wb")
    failas.write(struct.pack('L', zingsniai))
    duom.tofile(failas)
    failas.close()

for obj in bpy.data.objects:
    if(obj.type == 'MESH'):
        Skaiciuoti(obj)
        break

print("Baigta")